diff --git a/drivers/power/reset/Kconfig b/drivers/power/reset/Kconfig
index fece990af4a7..c59529ce25a2 100644
--- a/drivers/power/reset/Kconfig
+++ b/drivers/power/reset/Kconfig
@@ -148,6 +148,18 @@ config POWER_RESET_ODROID_GO_ULTRA_POWEROFF
 	help
 	  This driver supports Power off for Odroid Go Ultra device.
 
+config POWER_RESET_PHOTONICAT_POWEROFF
+	tristate "Photonicat PMU power-off driver"
+	depends on MFD_PHOTONICAT_PMU
+	help
+	  This driver supports Power off for Photonicat PMU device.
+
+	  Supports operations:
+	    Host notifies PMU to shutdown
+	    PMU notifies host to shutdown
+
+	  Say Y if you have a Photonicat board.
+
 config POWER_RESET_PIIX4_POWEROFF
 	tristate "Intel PIIX4 power-off driver"
 	depends on PCI
diff --git a/drivers/power/reset/Makefile b/drivers/power/reset/Makefile
index a95d1bd275d1..339b36812b95 100644
--- a/drivers/power/reset/Makefile
+++ b/drivers/power/reset/Makefile
@@ -17,6 +17,7 @@ obj-$(CONFIG_POWER_RESET_MT6323) += mt6323-poweroff.o
 obj-$(CONFIG_POWER_RESET_QCOM_PON) += qcom-pon.o
 obj-$(CONFIG_POWER_RESET_OCELOT_RESET) += ocelot-reset.o
 obj-$(CONFIG_POWER_RESET_ODROID_GO_ULTRA_POWEROFF) += odroid-go-ultra-poweroff.o
+obj-$(CONFIG_POWER_RESET_PHOTONICAT_POWEROFF) += photonicat-poweroff.o
 obj-$(CONFIG_POWER_RESET_PIIX4_POWEROFF) += piix4-poweroff.o
 obj-$(CONFIG_POWER_RESET_LTC2952) += ltc2952-poweroff.o
 obj-$(CONFIG_POWER_RESET_QNAP) += qnap-poweroff.o
diff --git a/drivers/power/reset/photonicat-poweroff.c b/drivers/power/reset/photonicat-poweroff.c
new file mode 100644
index 000000000000..f9f1ea179247
--- /dev/null
+++ b/drivers/power/reset/photonicat-poweroff.c
@@ -0,0 +1,95 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/*
+ * Copyright (c) 2024 Junhao Xie <bigfoot@classfun.cn>
+ */
+
+#include <linux/mfd/photonicat-pmu.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/reboot.h>
+
+struct pcat_poweroff {
+	struct device *dev;
+	struct pcat_pmu *pmu;
+	struct notifier_block nb;
+};
+
+static int pcat_do_poweroff(struct sys_off_data *data)
+{
+	struct pcat_poweroff *poweroff = data->cb_data;
+
+	dev_info(poweroff->dev, "Host request PMU shutdown\n");
+	pcat_pmu_write_data(poweroff->pmu, PCAT_CMD_HOST_REQUEST_SHUTDOWN,
+			    NULL, 0);
+
+	return NOTIFY_DONE;
+}
+
+static int pcat_poweroff_notify(struct notifier_block *nb, unsigned long action,
+				void *data)
+{
+	struct pcat_poweroff *poweroff =
+		container_of(nb, struct pcat_poweroff, nb);
+
+	if (action != PCAT_CMD_PMU_REQUEST_SHUTDOWN)
+		return NOTIFY_DONE;
+
+	dev_info(poweroff->dev, "PMU request host shutdown\n");
+	orderly_poweroff(true);
+
+	return NOTIFY_DONE;
+}
+
+static int pcat_poweroff_probe(struct platform_device *pdev)
+{
+	int ret;
+	struct device *dev = &pdev->dev;
+	struct pcat_poweroff *poweroff;
+
+	poweroff = devm_kzalloc(dev, sizeof(*poweroff), GFP_KERNEL);
+	if (!poweroff)
+		return -ENOMEM;
+
+	poweroff->dev = dev;
+	poweroff->pmu = dev_get_drvdata(dev->parent);
+	poweroff->nb.notifier_call = pcat_poweroff_notify;
+	platform_set_drvdata(pdev, poweroff);
+
+	ret = devm_register_sys_off_handler(&pdev->dev,
+					    SYS_OFF_MODE_POWER_OFF,
+					    SYS_OFF_PRIO_DEFAULT,
+					    pcat_do_poweroff,
+					    poweroff);
+	if (ret)
+		return ret;
+
+	return pcat_pmu_register_notify(poweroff->pmu, &poweroff->nb);
+}
+
+static void pcat_poweroff_remove(struct platform_device *pdev)
+{
+	struct pcat_poweroff *poweroff = platform_get_drvdata(pdev);
+
+	pcat_pmu_unregister_notify(poweroff->pmu, &poweroff->nb);
+}
+
+static const struct of_device_id pcat_poweroff_dt_ids[] = {
+	{ .compatible = "ariaboard,photonicat-pmu-poweroff", },
+	{ /* sentinel */ }
+};
+MODULE_DEVICE_TABLE(of, pcat_poweroff_dt_ids);
+
+static struct platform_driver pcat_poweroff_driver = {
+	.driver = {
+		.name = "photonicat-poweroff",
+		.of_match_table = pcat_poweroff_dt_ids,
+	},
+	.probe = pcat_poweroff_probe,
+	.remove = pcat_poweroff_remove,
+};
+module_platform_driver(pcat_poweroff_driver);
+
+MODULE_AUTHOR("Junhao Xie <bigfoot@classfun.cn>");
+MODULE_DESCRIPTION("Photonicat PMU Poweroff");
+MODULE_LICENSE("GPL");